VERSION 2.00
Begin Form frmCalibrate 
   BorderStyle     =   3  'Fixed Double
   Caption         =   "Rotator Calibration"
   ClientHeight    =   1992
   ClientLeft      =   2112
   ClientTop       =   1680
   ClientWidth     =   5820
   ControlBox      =   0   'False
   Height          =   2388
   Left            =   2076
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1992
   ScaleWidth      =   5820
   Top             =   1320
   Width           =   5892
   Begin CommandButton cmdHelp 
      Caption         =   "Help"
      Height          =   444
      Left            =   4716
      TabIndex        =   7
      Top             =   540
      Width           =   984
   End
   Begin CommandButton cmdQuit 
      Caption         =   "Quit"
      Height          =   444
      Left            =   4716
      TabIndex        =   6
      Top             =   1008
      Width           =   984
   End
   Begin CommandButton cmdSave 
      Caption         =   "Save"
      Height          =   444
      Left            =   4716
      TabIndex        =   5
      Top             =   1476
      Width           =   984
   End
   Begin CommandButton cmdCal 
      Caption         =   "Cal - Zenith"
      Height          =   444
      Index           =   3
      Left            =   1548
      TabIndex        =   4
      Top             =   612
      Width           =   1452
   End
   Begin CommandButton cmdCal 
      Caption         =   "Cal - Horizon"
      Height          =   444
      Index           =   2
      Left            =   1548
      TabIndex        =   3
      Top             =   1512
      Width           =   1452
   End
   Begin CommandButton cmdCal 
      Caption         =   "Cal - Az CW"
      Height          =   444
      Index           =   1
      Left            =   3024
      TabIndex        =   2
      Top             =   1080
      Width           =   1452
   End
   Begin CommandButton cmdCal 
      Caption         =   "Cal - Az CCW"
      Height          =   444
      Index           =   0
      Left            =   36
      TabIndex        =   0
      Top             =   1080
      Width           =   1452
   End
   Begin Label Label1 
      Caption         =   "Manually adjust rotator position, then click correspoonding button.  Click ""Save"" when done."
      Height          =   480
      Left            =   432
      TabIndex        =   1
      Top             =   72
      Width           =   4980
   End
End
Option Explicit
Option Compare Text

Dim ZenithVolts As Single
Dim HorizonVolts As Single
Dim AzCWVolts As Single
Dim AzCCWVolts As Single

Dim ZenithAngle As Single
Dim HorizonAngle As Single
Dim AzCWAngle As Single
Dim AzCCWAngle As Single

Dim ZenithADC As Single
Dim HorizonADC As Single
Dim AzCWADC As Single
Dim AzCCWADC As Single

Dim TempAz As Rotator, TempEl As Rotator

Sub cmdCal_Click (Index As Integer)
Dim Response As String

Select Case Index
    Case 0 ' Az CCW
        Rem Read and store the ADC value
        AzCCWADC = ReadADC(Az.ADC.Channel)
        Az.ADC.Value = AzCCWADC

        Rem Compute provisional voltage and angles
        AzCCWVolts = ADCToVolts(Az.ADC)
        AzCCWAngle = ADCToAngle(Az)

        Rem ask for corrected voltage and angle
        Response = InputBox$("Enter the Azimuth rotator position voltage", "Calibrate", Str$(Az.ADC.Volts))
        If IsNumeric(Response) Then
            AzCCWVolts = Val(Response)
        End If
        Response = InputBox$("Enter the Azimuth rotator position (degrees)", "Calibrate", Str$(AzCCWAngle))
        If IsNumeric(Response) Then
            AzCCWAngle = Val(Response)
        End If
    Case 1 ' Az CW
        Rem Read and store the ADC value
        AzCWADC = ReadADC(Az.ADC.Channel)
        Az.ADC.Value = AzCWADC

        Rem Compute provisional voltage and angles
        AzCWVolts = ADCToVolts(Az.ADC)
        AzCWAngle = ADCToAngle(Az)

        Rem ask for corrected voltage and angle
        Response = InputBox$("Enter the Azimuth rotator position voltage", "Calibrate", Str$(Az.ADC.Volts))
        If IsNumeric(Response) Then
            AzCWVolts = Val(Response)
        End If
        Response = InputBox$("Enter the Azimuth rotator position (degrees)", "Calibrate", Str$(AzCWAngle))
        If IsNumeric(Response) Then
            AzCWAngle = Val(Response)
        End If
    Case 2 ' El CCW  (Horizon)
        Rem Read and store the ADC value
        HorizonADC = ReadADC(El.ADC.Channel)
        El.ADC.Value = HorizonADC

        Rem Compute provisional voltage and angles
        HorizonVolts = ADCToVolts(El.ADC)
        HorizonAngle = ADCToAngle(El)

        Rem ask for corrected voltage and angle
        Response = InputBox$("Enter the Elevation rotator position voltage", "Calibrate", Str$(El.ADC.Volts))
        If IsNumeric(Response) Then
            HorizonVolts = Val(Response)
        End If
        Response = InputBox$("Enter the Elevation rotator position (degrees)", "Calibrate", Str$(HorizonAngle))
        If IsNumeric(Response) Then
            HorizonAngle = Val(Response)
        End If
    Case 3 ' El CW  (Zenith)
        Rem Read and store the ADC value
        ZenithADC = ReadADC(El.ADC.Channel)
        El.ADC.Value = ZenithADC

        Rem Compute provisional voltage and angles
        ZenithVolts = ADCToVolts(El.ADC)
        ZenithAngle = ADCToAngle(El)

        Rem ask for corrected voltage and angle
        Response = InputBox$("Enter the Elevation rotator position voltage", "Calibrate", Str$(El.ADC.Volts))
        If IsNumeric(Response) Then
            ZenithVolts = Val(Response)
        End If
        Response = InputBox$("Enter the Elevation rotator position (degrees)", "Calibrate", Str$(ZenithAngle))
        If IsNumeric(Response) Then
            ZenithAngle = Val(Response)
        End If
End Select

Rem Compute new values for Diagnostic display
Rem Compute and save gain and offset
El.ADC.Gain = (ZenithVolts - HorizonVolts) / (ZenithADC - HorizonADC)
El.ADC.Offset = ZenithVolts - El.ADC.Gain * ZenithADC

Az.ADC.Gain = (AzCWVolts - AzCCWVolts) / (AzCWADC - AzCCWADC)
Az.ADC.Offset = AzCWVolts - Az.ADC.Gain * AzCWADC

Rem Transfer all values to the active arrays
Az.CWLimit = AzCWAngle
Az.CCWLimit = AzCCWAngle
Az.CWVolts = AzCWVolts
Az.CCWVolts = AzCCWVolts

El.CWLimit = ZenithAngle
El.CCWLimit = HorizonAngle
El.CWVolts = ZenithVolts
El.CCWVolts = HorizonVolts

End Sub

Sub cmdHelp_Click ()
Dim HelpErr As Integer

HelpErr = WinHelp(Me.hWnd, "Wprairie.HLP", HELP_KEY, ByVal "Calibration procedure")

End Sub

Sub cmdQuit_Click ()

Rem Restore original calibrations
Az = TempAz
El = TempEl
Unload Me

End Sub

Sub cmdSave_Click ()
Rem Save all settings
Dim E As Integer
Dim Gain As Single, Offset As Single, ChanString As String

Rem Test for zero ranges which could cause later crashes
If AzCWADC = AzCCWADC Then
    MsgBox "Error in Azimuth Calibration: No difference (CW-CCW)! Try again"
    Exit Sub
End If
If HorizonADC = ZenithADC Then
    MsgBox "Error in Elevation Calibration: No difference (CW-CCW)! Try again"
    Exit Sub
End If

Rem Write out the angles and voltages directly
E = WritePrivateProfileString("Rotors", "ElCCWLimit", Str$(HorizonAngle), IniFileName)
E = WritePrivateProfileString("Rotors", "ElCWLimit", Str$(ZenithAngle), IniFileName)
E = WritePrivateProfileString("Rotors", "AzCCWLimit", Str$(AzCCWAngle), IniFileName)
E = WritePrivateProfileString("Rotors", "ElCWLimit", Str$(AzCWAngle), IniFileName)

E = WritePrivateProfileString("Rotors", "ElCCWVolts", Str$(HorizonVolts), IniFileName)
E = WritePrivateProfileString("Rotors", "ElCWVolts", Str$(ZenithVolts), IniFileName)
E = WritePrivateProfileString("Rotors", "AzCCWVolts", Str$(AzCCWVolts), IniFileName)
E = WritePrivateProfileString("Rotors", "ElCWVolts", Str$(AzCWVolts), IniFileName)

Rem Compute and save gain and offset
Gain = (ZenithVolts - HorizonVolts) / (ZenithADC - HorizonADC)
Offset = ZenithVolts - Gain * ZenithADC
ChanString = "ADC" & Format$(El.ADC.Channel) & "Gain"
E = WritePrivateProfileString("PrairieBoard", ChanString, Str$(Gain), IniFileName)
ChanString = "ADC" & Format$(El.ADC.Channel) & "Offset"
E = WritePrivateProfileString("PrairieBoard", ChanString, Str$(Offset), IniFileName)
El.ADC.Gain = Gain
El.ADC.Offset = Offset

Gain = (AzCWVolts - AzCCWVolts) / (AzCWADC - AzCCWADC)
Offset = AzCWVolts - Gain * AzCWADC
ChanString = "ADC" & Format$(Az.ADC.Channel) & "Gain"
E = WritePrivateProfileString("PrairieBoard", ChanString, Str$(Gain), IniFileName)
ChanString = "ADC" & Format$(Az.ADC.Channel) & "Offset"
E = WritePrivateProfileString("PrairieBoard", ChanString, Str$(Offset), IniFileName)
Az.ADC.Gain = Gain
Az.ADC.Offset = Offset

Rem Transfer all values to the active arrays
Az.CWLimit = AzCWAngle
Az.CCWLimit = AzCCWAngle
Az.CWVolts = AzCWVolts
Az.CCWVolts = AzCCWVolts

El.CWLimit = ZenithAngle
El.CCWLimit = HorizonAngle
El.CWVolts = ZenithVolts
El.CCWVolts = HorizonVolts

Unload Me

End Sub

Sub Form_Load ()

Left = (Screen.Width - Width) / 2
Top = (Screen.Height - Height) / 2

Rem Save the current calibrations
TempAz = Az
TempEl = El

Rem Fill in the present values of Volts, Angles
ZenithVolts = El.CWVolts
HorizonVolts = El.CCWVolts
AzCWVolts = Az.CWVolts
AzCCWVolts = Az.CCWVolts

ZenithAngle = El.CWLimit
HorizonAngle = El.CCWLimit
AzCWAngle = Az.CWLimit
AzCCWAngle = Az.CCWLimit

Rem Compute the corresponding ADC values and fill them in
Rem   Note that the .INI file stores the full range of
Rem   the ADC, not the range used by the rotator!
ZenithADC = (ZenithVolts - El.ADC.Offset) / El.ADC.Gain
HorizonADC = (HorizonVolts - El.ADC.Offset) / El.ADC.Gain
AzCWADC = (AzCWVolts - El.ADC.Offset) / El.ADC.Gain
AzCCWADC = (AzCCWVolts - El.ADC.Offset) / El.ADC.Gain

End Sub

